Differences between revisions 6 and 41 (spanning 35 versions)
Revision 6 as of 2007-10-15 02:28:34
Size: 6967
Editor: GreyCat
Comment: simplify
Revision 41 as of 2019-06-03 14:26:04
Size: 11340
Editor: 151
Comment: + link
Deletions are marked like this. Additions are marked like this.
Line 1: Line 1:
[[Anchor(faq28)]] <<Anchor(faq28)>>
Line 3: Line 3:
This topic comes up frequently. This answer covers not only the expression used above ("configuration files"), but also several variant situations. If you've been directed here, please read this entire answer before dismissing it. There are two prime reasons why this issue comes up: either you want to externalize data or configuration of your script and need a way to find these external resources, or your script is intended to act upon a bundle of some sort (eg. a build script), and needs to find the resources to act upon.
Line 5: Line 5:
This is a complex question because there's no single right answer to it. Even worse: it's not possible to find the location reliably in 100% of all cases. All ways of finding a script's location depend on the name of the script, as seen in the predefined variable {{{$0}}}. But providing the script name in {{{$0}}} is only a (very common) convention, not a requirement. It is important to realize that in the general case, this problem has no solution. Any approach you might have heard of, and any approach that will be detailed below, has flaws and will only work in specific cases. First and foremost, try to avoid the problem entirely by not depending on the location of your script!
Line 7: Line 7:
The suspect answer is "in some shells, $0 is always an absolute path, even if you invoke the script using a relative path, or no path at all". But this isn't reliable across shells; some of them (including ["BASH"]) return the actual command typed in by the user instead of the fully qualified path. And this is just the tip of the iceberg! Before we dive into solutions, let's clear up some misunderstandings. It is important to understand that:
Line 9: Line 9:
Your script may not actually be on a locally accessible disk ''at all''. Consider this:  * Your script does '''not''' actually have a location! Wherever the bytes end up coming from, there is no "one canonical path" for it. Never.
 * {{{$0}}} is NOT the answer to your problem. If you think it is, you can either stop reading and write more bugs, or you can accept this and read on.


=== I need to access my data/config files ===

Very often, people want to make their scripts configurable. The separation principle teaches us that it's a good idea to keep configuration and code separate. The problem then ends up being: how does my script know where to find the user's configuration file for it?

Too often, people believe the configuration of a script should reside in the same directory where they put their script. This is the root of the problem.

''A UNIX paradigm exists'' to solve this problem for you: '''configuration artifacts of your scripts should exist in either the user's {{{HOME}}} directory or {{{/etc}}}'''. That gives your script an absolute path to look for the file, solving your problem instantly: you no longer depend on the "location" of your script:

{{{
    if [[ -e ~/.myscript.conf ]]; then source ~/.myscript.conf
    elif [[ -e /etc/myscript.conf ]]; then source /etc/myscript.conf
    fi
}}}

The same holds true for other types of data files. Logs should be written to {{{/var/log}}} or the user's home directory. Support files should be installed to an absolute path in the file system or be made available alongside the configuration in {{{/etc}}} or the user's home directory.


=== I need to access files bundled with my script ===

Sometimes scripts are part of a "bundle" and perform certain actions within or upon it. This is often true for applications unpacked or contained within a bundle directory. The user may unpack or install the bundle anywhere; ideally, the bundle's scripts should work whether that's somewhere in a home dir, or {{{/var/tmp}}}, or {{{/usr/local}}}. The files are transient, and have no fixed or predictable location.

When a script needs to act upon other files it's bundled with, independently of its absolute location, we have two options: '''either we rely on {{{PWD}}} or we rely on {{{BASH_SOURCE}}}'''. Both approaches have certain issues; here's what you need to know.

==== Using BASH_SOURCE ====

The {{{BASH_SOURCE}}} internal bash variable is actually an array of pathnames. If you expand it as a simple string, e.g. '''{{{"$BASH_SOURCE"}}}''', you'll get the first element, which '''is the pathname of the currently executing function or script'''. Using the {{{BASH_SOURCE}}} method, you access files within your bundle like this:

{{{
    cd "${BASH_SOURCE%/*}/" || exit # cd into the bundle and use relative paths
    read somevar < etc/somefile

    read somevar < "${BASH_SOURCE%/*}/etc/somefile" # If you want an absolute pathname
}}}

Please note that when using {{{BASH_SOURCE}}}, the ''following caveats'' apply:

 * {{{$BASH_SOURCE}}} expands ''empty'' when bash does not know where the executing code comes from. Usually, this means the code is coming from ''standard input'' (e.g. ssh host 'somecode', or from an interactive session).
 * {{{$BASH_SOURCE}}} does ''not follow'' symlinks (when you run {{{z}}} from {{{/x/y}}}, you get {{{/x/y/z}}}, even if that is a symlink to {{{/p/q/r}}}). Often, this is the desired effect. Sometimes, though, it's not. Imagine your package links its start-up script into {{{/usr/local/bin}}}. Now that script's {{{BASH_SOURCE}}} will lead you into {{{/usr/local}}} and not into the package.

If you're not writing a bash script, the {{{BASH_SOURCE}}} variable is unavailable to you. There is a common convention, however, for passing the location of the script as the process name when it is started. Most shells do this, but not all shells do so reliably, and not all of them attempt to resolve a relative path to an absolute path. Relying on this behaviour is dangerous and fragile, but can be done by looking at {{{$0}}} ([[#Why $0 is NOT an option|see below]]). Again, consider all your options before doing this: you are likely creating more problems than you are solving.

==== Using PWD ====

Another option is to rely on {{{PWD}}}, the current working directory. In this case, you can '''assume the user has first {{{cd}}}'ed into your bundle and make all your pathnames relative'''. Using the PWD method, you access files within your bundle like this:

{{{
    read somevar < etc/somefile # Using pathname relative to PWD
    read somevar < "$PWD/etc/somefile" # Expand PWD if you want an absolute pathname
    bundleDir=$PWD # Store PWD if you expect to cd in your script.
    read somefile < "$bundleDir/etc/somefile"
}}}

To reduce fragility, you could even test whether, for example, the relative path to the script name is correct, to make sure the user has indeed {{{cd}}}'ed into the bundle:

{{{
    [[ -e bin/myscript ]] || { echo >&2 "Please cd into the bundle before running this script."; exit 1; }
}}}

You can also try some heuristics, just in case the user is sitting one directory above the bundle:

{{{
    if [[ ! -e bin/myscript ]]; then
        if [[ -d mybundle-1.2.5 ]]; then
            cd mybundle-1.2.5 || { echo >&2 "Bundle directory exists but I can't cd there."; exit 1; }
        else
            echo >&2 "Please cd into the bundle before running this script."; exit 1;
        fi
    fi
}}}

If you ever do need an absolute path, you can always get one by prefixing the relative path with {{{$PWD}}}: {{{echo "Saved to: $PWD/result.csv"}}}

The only difficulty here is that you're forcing your user to change into your bundle's directory before your script can function. Regardless, this may well be your best option!

==== Using a configuration/wrapper ====

If neither the {{{BASH_SOURCE}}} or the {{{PWD}}} option sound interesting, you might want to consider going the route of configuration files instead (see the previous section). In this case, you require that your user set the location of your bundle in a configuration file, and have him put that configuration file in a location you can easily find. For example:

{{{
    [[ -e ~/.myscript.conf ]] || { echo >&2 "First configure the product in ~/.myscript.conf"; exit 1; }
    source ~/.myscript.conf # ~/.myscript.conf defines something like bundleDir=/x/y
    [[ $bundleDir ]] || { echo >&2 "Please define bundleDir='/some/path' in ~/.myscript.conf"; exit 1; }
    cd "$bundleDir" || { echo >&2 "Could not cd to <$bundleDir>"; exit 1; }

    # Now you can use the PWD method: use relative paths.
}}}

A variant of this option is to use a wrapper that configures your bundle's location. Instead of calling your bundled script, you install a wrapper for your script in the standard system {{{PATH}}}, which changes directory into the bundle and calls the real script from there, which can then safely use the {{{PWD}}} method from above:

{{{
    #!/usr/bin/env bash
    cd /path/to/where/bundle/was/installed
    exec "bin/realscript"
}}}

=== Why $0 is NOT an option ===

Common ways of finding a script's location depend on the name of the script, as seen in the predefined variable {{{$0}}}. Unfortunately, providing the script name via {{{$0}}} is only a (common) convention, not a requirement. In fact, `$0` is not at all the location of your script, it's the '''name''' of your process as determined by your parent. It can be ''anything''.

The suspect answer is "in some shells, $0 is always an absolute path, even if you invoke the script using a relative path, or no path at all". But this isn't reliable across shells; some of them (including [[BASH]]) return the actual command typed in by the user instead of the fully qualified path. And this is just the tip of the iceberg!

Consider that your script may not actually be on a locally accessible disk ''at all''. Consider this:
Line 14: Line 119:
Line 19: Line 123:
(That may sound fanciful, but it's actually very common. Consider a script installed in `/opt/foobar/bin`, which is running at the time someone upgrades foobar to a new version. They may delete the entire `/opt/foobar/` hierarchy, or they may move the `/opt/foobar/bin/foobar` script to a temporary name before putting a new version in place. For these reasons, even approaches like "use `lsof` to find the file which the shell is using as standard input" will ''still'' fail.)
Line 21: Line 127:
(For a more general discussion of the Unix file system and how symbolic links affect your ability to know where you are at any given moment, see [http://www.cs.bell-labs.com/sys/doc/lexnames.html this Plan 9 paper].) Some people will try to work around the symlink issue with `readlink -f "$0"`. Again, this may work in ''some'' cases, but it's not bulletproof. Nothing that reads `$0` will ever be bulletproof, because `$0` ''itself'' is unreliable. Furthermore, `readlink` is nonstandard, and won't be available on all platforms.
Line 23: Line 129:
Having said all that, if you ''still'' want to make a whole slew of naive assumptions, and all you want is the fully qualified version of $0, you can use something like this (["POSIX"], non-Bourne): For a more general discussion of the Unix file system and how symbolic links affect your ability to know where you are at any given moment, see [[http://doc.cat-v.org/plan_9/4th_edition/papers/lexnames|this Plan 9 paper]].
Line 25: Line 131:
{{{
  [[ $0 = /* ]] && echo $0 || echo $PWD/$0
}}}

Or the BourneShell version:

{{{
  case $0 in /*) echo $0;; *) echo `pwd`/$0;; esac
}}}

Or a shell-independent variant (needs a {{{readlink(1)}}} supporting {{{-f}}}, though, so it's OS-dependent):

{{{
  readlink -f "$0"
}}}

If we want to account for the cases where the script's relative pathname (in {{{$0}}}) may be relative to a {{{$PATH}}} component instead of the current working directory (as mentioned above), we can still try to search the script like the shell would have done: in all directories from {{{$PATH}}}.

The following script shows how this could be done:

{{{
#!/bin/bash

myname=$0
if [ -s "$myname" ] && [ -x "$myname" ]; then
    # $myname is already a valid file name

    mypath=$myname
else
    case "$myname" in
    /*) exit 1;; # absolute path - do not search PATH
    *)
        # Search all directories from the PATH variable. Take
        # care to interpret leading and trailing ":" as meaning
        # the current directory; the same is true for "::" within
        # the PATH.
    
        # Replace leading : with . in PATH, store in p
        p=${PATH/#:/.:}
        # Replace trailing : with .
        p=${p//%:/:.}
        # Replace :: with .
        p=${p//::/:.:}
        # Temporary input field separator, see FAQ #1
        OFS=$IFS; IFS=:
        # Split the path on colons and loop through each of them
        for dir in $p; do
                [ -f "$dir/$myname" ] || continue # no file
                [ -x "$dir/$myname" ] || continue # not executable
                mypath=$dir/$myname
                break # only return first matching file
        done
        # Restore old input field separator
        IFS=$OFS
        ;;
    esac
fi

if [ ! -f "$mypath" ]; then
    echo >&2 "cannot find full path name: $myname"
    exit 1
fi

echo >&2 "path of this script: $mypath"
}}}

Note that {{{$mypath}}} is not necessarily an absolute path name. It still can contain relative parts like {{{../bin/myscript}}}.

Are you starting to see how ridiculously complex this problem is becoming? And this is ''still'' just the simplistic case where we've made a lot of assumptions about the script not moving and not being piped in!

Generally, storing data files in the same directory as their programs is a bad practise. The Unix file system layout assumes that files in one place (e.g. {{{/bin}}}) are executable programs, while files in another place (e.g. {{{/etc}}}) are data files. (Let's ignore legacy Unix systems with programs in {{{/etc}}} for the moment, shall we....)

Here are some common sense alternatives you should consider, instead of attempting to perform the impossible:
 * It really makes the most sense to keep your script's configuration in a single, static location such as {{{/etc/foobar.conf}}}.
 * If you need to define multiple configuration files, then you can have a directory (say, {{{/var/lib/foobar/}}} or {{{/usr/local/lib/foobar/}}}), and read that directory's location from a fixed place such as {{{/etc/foobar.conf}}}.
 * If you don't even want that much to be hard-coded, you could pass the location of {{{foobar.conf}}} (or of your configuration directory itself) as a parameter to the script.
 * If you need the script to assume certain default in the absence of {{{/etc/foobar.conf}}}, you can put defaults in the script itself, or fall back to something like {{{$HOME/.foobar.conf}}} if {{{/etc/foobar.conf}}} is missing.
 * When you install the script on a target system, you could put the script's location into a variable in the script itself. The information is available at that point, and as long as the script doesn't move, it will always remain correct for each installed system.
 * In most cases, it makes more sense to abort gracefully if your configuration data can't be found by obvious means, rather than going through arcane processes and possibly coming up with wrong answers.
----
CategoryShell

How do I determine the location of my script? I want to read some config files from the same place.

There are two prime reasons why this issue comes up: either you want to externalize data or configuration of your script and need a way to find these external resources, or your script is intended to act upon a bundle of some sort (eg. a build script), and needs to find the resources to act upon.

It is important to realize that in the general case, this problem has no solution. Any approach you might have heard of, and any approach that will be detailed below, has flaws and will only work in specific cases. First and foremost, try to avoid the problem entirely by not depending on the location of your script!

Before we dive into solutions, let's clear up some misunderstandings. It is important to understand that:

  • Your script does not actually have a location! Wherever the bytes end up coming from, there is no "one canonical path" for it. Never.

  • $0 is NOT the answer to your problem. If you think it is, you can either stop reading and write more bugs, or you can accept this and read on.

I need to access my data/config files

Very often, people want to make their scripts configurable. The separation principle teaches us that it's a good idea to keep configuration and code separate. The problem then ends up being: how does my script know where to find the user's configuration file for it?

Too often, people believe the configuration of a script should reside in the same directory where they put their script. This is the root of the problem.

A UNIX paradigm exists to solve this problem for you: configuration artifacts of your scripts should exist in either the user's HOME directory or /etc. That gives your script an absolute path to look for the file, solving your problem instantly: you no longer depend on the "location" of your script:

    if [[ -e ~/.myscript.conf ]]; then source ~/.myscript.conf
    elif [[ -e /etc/myscript.conf ]]; then source /etc/myscript.conf
    fi

The same holds true for other types of data files. Logs should be written to /var/log or the user's home directory. Support files should be installed to an absolute path in the file system or be made available alongside the configuration in /etc or the user's home directory.

I need to access files bundled with my script

Sometimes scripts are part of a "bundle" and perform certain actions within or upon it. This is often true for applications unpacked or contained within a bundle directory. The user may unpack or install the bundle anywhere; ideally, the bundle's scripts should work whether that's somewhere in a home dir, or /var/tmp, or /usr/local. The files are transient, and have no fixed or predictable location.

When a script needs to act upon other files it's bundled with, independently of its absolute location, we have two options: either we rely on PWD or we rely on BASH_SOURCE. Both approaches have certain issues; here's what you need to know.

Using BASH_SOURCE

The BASH_SOURCE internal bash variable is actually an array of pathnames. If you expand it as a simple string, e.g. "$BASH_SOURCE", you'll get the first element, which is the pathname of the currently executing function or script. Using the BASH_SOURCE method, you access files within your bundle like this:

    cd "${BASH_SOURCE%/*}/" || exit                            # cd into the bundle and use relative paths
    read somevar < etc/somefile

    read somevar < "${BASH_SOURCE%/*}/etc/somefile"            # If you want an absolute pathname

Please note that when using BASH_SOURCE, the following caveats apply:

  • $BASH_SOURCE expands empty when bash does not know where the executing code comes from. Usually, this means the code is coming from standard input (e.g. ssh host 'somecode', or from an interactive session).

  • $BASH_SOURCE does not follow symlinks (when you run z from /x/y, you get /x/y/z, even if that is a symlink to /p/q/r). Often, this is the desired effect. Sometimes, though, it's not. Imagine your package links its start-up script into /usr/local/bin. Now that script's BASH_SOURCE will lead you into /usr/local and not into the package.

If you're not writing a bash script, the BASH_SOURCE variable is unavailable to you. There is a common convention, however, for passing the location of the script as the process name when it is started. Most shells do this, but not all shells do so reliably, and not all of them attempt to resolve a relative path to an absolute path. Relying on this behaviour is dangerous and fragile, but can be done by looking at $0 (see below). Again, consider all your options before doing this: you are likely creating more problems than you are solving.

Using PWD

Another option is to rely on PWD, the current working directory. In this case, you can assume the user has first cd'ed into your bundle and make all your pathnames relative. Using the PWD method, you access files within your bundle like this:

    read somevar < etc/somefile                 # Using pathname relative to PWD
    read somevar < "$PWD/etc/somefile"          # Expand PWD if you want an absolute pathname
    bundleDir=$PWD                              # Store PWD if you expect to cd in your script.
    read somefile < "$bundleDir/etc/somefile"

To reduce fragility, you could even test whether, for example, the relative path to the script name is correct, to make sure the user has indeed cd'ed into the bundle:

    [[ -e bin/myscript ]] || { echo >&2 "Please cd into the bundle before running this script."; exit 1; }

You can also try some heuristics, just in case the user is sitting one directory above the bundle:

    if [[ ! -e bin/myscript ]]; then
        if [[ -d mybundle-1.2.5 ]]; then
            cd mybundle-1.2.5 || { echo >&2 "Bundle directory exists but I can't cd there."; exit 1; }
        else
            echo >&2 "Please cd into the bundle before running this script."; exit 1;
        fi
    fi

If you ever do need an absolute path, you can always get one by prefixing the relative path with $PWD: echo "Saved to: $PWD/result.csv"

The only difficulty here is that you're forcing your user to change into your bundle's directory before your script can function. Regardless, this may well be your best option!

Using a configuration/wrapper

If neither the BASH_SOURCE or the PWD option sound interesting, you might want to consider going the route of configuration files instead (see the previous section). In this case, you require that your user set the location of your bundle in a configuration file, and have him put that configuration file in a location you can easily find. For example:

    [[ -e ~/.myscript.conf ]] || { echo >&2 "First configure the product in ~/.myscript.conf"; exit 1; }
    source ~/.myscript.conf      # ~/.myscript.conf defines something like bundleDir=/x/y
    [[ $bundleDir ]]          || { echo >&2 "Please define bundleDir='/some/path' in ~/.myscript.conf"; exit 1; }
    cd "$bundleDir"           || { echo >&2 "Could not cd to <$bundleDir>"; exit 1; }

    # Now you can use the PWD method: use relative paths.

A variant of this option is to use a wrapper that configures your bundle's location. Instead of calling your bundled script, you install a wrapper for your script in the standard system PATH, which changes directory into the bundle and calls the real script from there, which can then safely use the PWD method from above:

    #!/usr/bin/env bash
    cd /path/to/where/bundle/was/installed
    exec "bin/realscript"

Why $0 is NOT an option

Common ways of finding a script's location depend on the name of the script, as seen in the predefined variable $0. Unfortunately, providing the script name via $0 is only a (common) convention, not a requirement. In fact, $0 is not at all the location of your script, it's the name of your process as determined by your parent. It can be anything.

The suspect answer is "in some shells, $0 is always an absolute path, even if you invoke the script using a relative path, or no path at all". But this isn't reliable across shells; some of them (including BASH) return the actual command typed in by the user instead of the fully qualified path. And this is just the tip of the iceberg!

Consider that your script may not actually be on a locally accessible disk at all. Consider this:

  ssh remotehost bash < ./myscript

The shell running on remotehost is getting its commands from a pipe. There's no script anywhere on any disk that bash can see.

Moreover, even if your script is stored on a local disk and executed, it could move. Someone could mv the script to another location in between the time you type the command and the time your script checks $0. Or someone could have unlinked the script during that same time window, so that it doesn't actually have a link within a file system any more.

(That may sound fanciful, but it's actually very common. Consider a script installed in /opt/foobar/bin, which is running at the time someone upgrades foobar to a new version. They may delete the entire /opt/foobar/ hierarchy, or they may move the /opt/foobar/bin/foobar script to a temporary name before putting a new version in place. For these reasons, even approaches like "use lsof to find the file which the shell is using as standard input" will still fail.)

Even in the cases where the script is in a fixed location on a local disk, the $0 approach still has some major drawbacks. The most important is that the script name (as seen in $0) may not be relative to the current working directory, but relative to a directory from the program search path $PATH (this is often seen with KornShell). Or (and this is most likely problem by far...) there might be multiple links to the script from multiple locations, one of them being a simple symlink from a common PATH directory like /usr/local/bin, which is how it's being invoked. Your script might be in /opt/foobar/bin/script but the naive approach of reading $0 won't tell you that -- it may say /usr/local/bin/script instead.

Some people will try to work around the symlink issue with readlink -f "$0". Again, this may work in some cases, but it's not bulletproof. Nothing that reads $0 will ever be bulletproof, because $0 itself is unreliable. Furthermore, readlink is nonstandard, and won't be available on all platforms.

For a more general discussion of the Unix file system and how symbolic links affect your ability to know where you are at any given moment, see this Plan 9 paper.


CategoryShell

BashFAQ/028 (last edited 2019-06-03 14:26:04 by 151)